package com.sun.beans.decoder;

import java.beans.Expression;
import java.util.Locale;

class ObjectElementHandler extends NewElementHandler
{
    private String idref;
    private String field;
    private Integer index;
    private String property;
    private String method;
    
    ObjectElementHandler() {
    }
    
    @Override
    public final void addAttribute(String s, String idref) {
        if (s.equals("idref")) {
            this.idref = idref;
        }
        else if (s.equals("field")) {
            this.field = idref;
        }
        else if (s.equals("index")) {
            this.addArgument(this.index = Integer.valueOf(idref));
        }
        else if (s.equals("property")) {
            this.property = idref;
        }
        else if (s.equals("method")) {
            this.method = idref;
        }
        else {
            super.addAttribute(s, idref);
        }
    }
    
    @Override
    public final void startElement() {
        if (this.field != null || this.idref != null) {
            super.getValueObject();
        }
    }
    
    @Override
    protected boolean isArgument() {
        return true;
    }
    
    protected final ValueObject getValueObject(Class<?> clazz, Object[] arguments) throws Exception {
        if (this.field != null) {
            return ValueObjectImpl.create(FieldElementHandler.getFieldValue(this.getContextBean(), this.field));
        }
        if (this.idref != null) {
            return ValueObjectImpl.create(this.getVariable(this.idref));
        }
        Object contextBean = this.getContextBean();
        String string;
        if (this.index != null) {
            string = ((arguments.length == 2) ? "set" : "get");
        }
        else if (this.property != null) {
            string = ((arguments.length == 1) ? "set" : "get");
            if (0 < this.property.length()) {
                string = string + this.property.substring(0, 1).toUpperCase(Locale.ENGLISH) + this.property.substring(1);
            }
        }
        else {
            string = ((this.method != null && 0 < this.method.length()) ? this.method : "new");
        }
        return ValueObjectImpl.create(new Expression(contextBean, string, arguments).getValue());
    }
}
